// Hakell frontend for Clean, 26.09.2003
definition module PreludeBuiltin

import StdEnv
import Prelude_


string_to_charlist_ :: !String -> [Char]

compare  	   		:: !a !a -> Ordering_ | == a & < a

concatMap f 		:== flatten o map f

runIO 				:: !(IO_ a) !*World -> *World

(catch_9) infixl 9
(catch_9) a b :== catch_ a b

(asTypeOf_9) infixl 9
(asTypeOf_9) a b :== asTypeOf_ a b

(:?.) infixr 5
(:?.) a b 			:== [a:b]

(:.) infixr 5
(:.) a b 			:== [a:b]

False_ 				:== False
True_ 				:== True

/////////////////////////////////


:: Char_ 			:== Char
:: Double_ 			:== Real
:: Float_ 			:== Real
:: Int_ 			:== Int
:: Integer_ 		:== Int
:: Bool_ 			:== Bool
:: Trivial_ 		= Trivial_
:: HugsException_ 	= HugsException_

:: IO_ a 	= IO_ ((IOError_ -> IOResult_) (a -> IOResult_) -> IOResult_)
			| IO (*World->*(a,*World))

////////////

seq_ 				:: !a !b -> b
$!. 				:: !(a -> b) !a -> b
primEqChar_     	:== (==)
primCmpChar_     	:== compare
primCharToInt_  	:== toInt
primIntToChar_  	:== toChar
primEqInt_      	:== (==)
primCmpInt_     	:== compare
primEqInteger_  	:== primEqInt_
primCmpInteger_    	:== primCmpInt_
primPlusInt_    	:== (+)
primMinusInt_   	:== (-)
primMulInt_     	:== (*)
primNegInt_     	:== (~)
primIntegerToInt_ 	:== id
primMinInt_     	:== -2147483647
primMaxInt_     	:== 2147483648
primPlusInteger_    :== primPlusInt_
primMinusInteger_   :== primMinusInt_
primMulInteger_     :== primMulInt_
primNegInteger_    	:== primNegInt_
primIntToInteger_   :== id
primDivInt_			:: !Int !Int -> Int
primQuotInt_		:== (/)
primRemInt_         :== (rem)
primModInt_         :: !Int !Int -> Int
primQrmInt_	a b		:== (a/b, a rem b)
primEvenInt_		:== isEven
primQrmInteger_		:== primQrmInt_
primEvenInteger_	:== primEvenInt_
primShowsInt_ p i s	:== fromString (toString i) ++ s
primShowsInteger_	:== primShowsInt_
primEqFloat_      	:== primEqDouble_
primCmpFloat_     	:== primCmpDouble_
primEqDouble_      	:== (==)
primCmpDouble_     	:== compare
primPlusFloat_    	:== primPlusDouble_
primMinusFloat_   	:== primMinusDouble_
primMulFloat_     	:== primMulDouble_
primNegFloat_     	:== primNegDouble_
primIntToFloat_ 	:== primIntToDouble_
primIntegerToFloat_	:== primIntegerToDouble_
primPlusDouble_    	:== (+)
primMinusDouble_   	:== (-)
primMulDouble_     	:== (*)
primNegDouble_     	:== (~)
primIntToDouble_ 	:== toReal
primIntegerToDouble_:== primIntToDouble_
primDivFloat_		:== primDivDouble_
doubleToFloat_		:== id
primDivDouble_		:== (/)
primRationalToFloat_:== primRationalToDouble_
primRationalToDouble_ :: !Rational_ -> Double_
primSinFloat_		:== primSinDouble_
primAsinFloat_		:== primAsinDouble_
primCosFloat_		:== primCosDouble_
primAcosFloat_		:== primAcosDouble_
primTanFloat_		:== primTanDouble_
primAtanFloat_		:== primAtanDouble_
primLogFloat_		:== primLogDouble_
primExpFloat_		:== primExpDouble_
primSqrtFloat_		:== primSqrtDouble_
primSinDouble_		:== sin
primAsinDouble_		:== asin
primCosDouble_		:== cos
primAcosDouble_		:== acos
primTanDouble_		:== tan
primAtanDouble_		:== atan
primLogDouble_		:== ln
primExpDouble_		:== exp
primSqrtDouble_		:== sqrt
primFloatRadix_		:== primDoubleRadix_
primFloatDigits_	:== primDoubleDigits_
primFloatMinExp_	:== primDoubleMinExp_
primFloatMaxExp_	:== primDoubleMaxExp_
primFloatEncode_	:== primDoubleEncode_
primFloatDecode_	:== primDoubleDecode_
primDoubleRadix_	:== abort "primDoubleRadix"
primDoubleDigits_	:== abort "primDoubleDigits"
primDoubleMinExp_	:== abort "primDoubleMinExp"
primDoubleMaxExp_	:== abort "primDoubleMaxExp"
primDoubleEncode_	:== abort "primDoubleEncode"
primDoubleDecode_	:== abort "primDoubleDecode"
primShowsFloat_		:== primShowsDouble_
primShowsDouble_ p i s	:== fromString (toString i) ++ s
error_ 				:== abort o toString
primbindIO_			:: !(IO_ a) (a -> IO_ b) -> IO_ b
primretIO_			:: a -> IO_ a
catch_				:: !(IO_ a) !(IOError_ -> IO_ a) -> IO_ a
ioError_ 			:: IOError_ -> IO_ a
putChar_			:: !Char -> IO_ Trivial_
putStr_				:: ![Char] -> IO_ Trivial_
getChar_ 			:: IO_ Char_
isEOFError_			:== abort "isEOFError"
getContents_		:== abort "getContents"
writeFile_			:== abort "writeFile"
appendFile_			:== abort "appendFile"
readFile_			:== abort "readFile"
unsafeCoerce_		:== abort "unsafeCoerce"
primCatchException_	:== abort "primCatchException"
primThrowException_	:== abort "primThrowException"
primShowException_	:== abort "primShowException"

/////////////

