implementation module PreludeBuiltin

import StdEnv
import Prelude_

string_to_charlist_ :: !String -> [Char]
string_to_charlist_ s = f 0
where
	f i
		| i==size s	= []
		= [s.[i]:f (i+1)]

compare  	   	:: !a !a -> Ordering_ | == a & < a
compare a b
	| a==b = EQ_
	| a<b = LT_
	= GT_

runIO :: !(IO_ a) !*World -> *World
runIO (IO f) x = snd (f x)

////////////////

seq_ :: !a !b -> b
seq_ a b = b

$!. :: !(a -> b) !a -> b
$!. a b = a b

catch_				:: !(IO_ a) !(IOError_ -> IO_ a) -> IO_ a
catch_ _ _= abort "catch"

primDivInt_			:: !Int !Int -> Int
primDivInt_ a b
	| (a<0) <> (b<0)	= a/b - 1
	= a/b

primModInt_         :: !Int !Int -> Int
primModInt_ a b
	| (a<0) <> (b<0)	= a rem b + b
	= a rem b

primRationalToDouble_ :: !Rational_ -> Double_
primRationalToDouble_ (a:%.b) = toReal a / toReal b

primbindIO_			:: !(IO_ a) (a -> IO_ b) -> IO_ b
primbindIO_ (IO f) g = IO h where
    h w
        # (a,w)= f w
        # (IO g)= g a
        = g w
                     
primretIO_			:: a -> IO_ a
primretIO_ a 	= IO \w= (a,w)   

ioError_ :: IOError_ -> IO_ a
ioError_ s 	= appCon (fwrites (toString (show_ s))) undef

putChar_			:: !Char -> IO_ Trivial_
putChar_ c 	= appCon (fwritec c) Trivial_

putStr_				:: ![Char] -> IO_ Trivial_
putStr_ s 	= appCon (fwrites (toString s)) Trivial_

getChar_ 			:: IO_ Char_
getChar_ 	= accCon \con= let (_,c,f)= freadc con in (c,f)

//getLine :: IO String
//getLine = accCon \con-> let (s,f)= freadline_ con in (string_to_charlist s,f) ----

//getContents :: IO String
//getContents = getLine -----

///////////////////////

accCon :: (*File->*(a,*File)) -> IO_ a
accCon g = IO f where
	f w
		# (con,w)= stdio w
		# (a,con)= g con
		# (_,w)= fclose con w
		= (a,w)

appCon f a = accCon \con= (a, f con)

///////////////////////


